Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.sln
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.sln	(revision 698)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.sln	(revision 698)
@@ -0,0 +1,32 @@
+Microsoft Visual Studio Solution File, Format Version 8.00
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IBRBillboardCloudTreeGeneratorCommandLine", "IBRBillboardCloudTreeGeneratorCommandLine.vcproj", "{3C400FBE-9DA8-4553-BEA9-ABEA8A2575F9}"
+	ProjectSection(ProjectDependencies) = postProject
+	EndProjectSection
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "IBRBillboardCloudTreeGenerator", "IBRBillboardCloudTreeGenerator.vcproj", "{CEA5C988-8998-4780-9EE5-D2414099E506}"
+	ProjectSection(ProjectDependencies) = postProject
+	EndProjectSection
+EndProject
+Global
+	GlobalSection(SolutionConfiguration) = preSolution
+		Debug = Debug
+		Release = Release
+	EndGlobalSection
+	GlobalSection(ProjectConfiguration) = postSolution
+		{3C400FBE-9DA8-4553-BEA9-ABEA8A2575F9}.Debug.ActiveCfg = Debug|Win32
+		{3C400FBE-9DA8-4553-BEA9-ABEA8A2575F9}.Debug.Build.0 = Debug|Win32
+		{3C400FBE-9DA8-4553-BEA9-ABEA8A2575F9}.Release.ActiveCfg = Release|Win32
+		{3C400FBE-9DA8-4553-BEA9-ABEA8A2575F9}.Release.Build.0 = Release|Win32
+		{CEA5C988-8998-4780-9EE5-D2414099E506}.Debug.ActiveCfg = Debug|Win32
+		{CEA5C988-8998-4780-9EE5-D2414099E506}.Debug.Build.0 = Debug|Win32
+		{CEA5C988-8998-4780-9EE5-D2414099E506}.Release.ActiveCfg = Release|Win32
+		{CEA5C988-8998-4780-9EE5-D2414099E506}.Release.Build.0 = Release|Win32
+	EndGlobalSection
+	GlobalSection(SolutionItems) = postSolution
+		..\Readme.txt = ..\Readme.txt
+	EndGlobalSection
+	GlobalSection(ExtensibilityGlobals) = postSolution
+	EndGlobalSection
+	GlobalSection(ExtensibilityAddIns) = postSolution
+	EndGlobalSection
+EndGlobal
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.vcproj
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.vcproj	(revision 698)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.vcproj	(revision 698)
@@ -0,0 +1,468 @@
+<?xml version="1.0" encoding="Windows-1252"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="7.10"
+	Name="IBRBillboardCloudTreeGenerator"
+	ProjectGUID="{CEA5C988-8998-4780-9EE5-D2414099E506}"
+	RootNamespace="BillboardCloudGenerator"
+	Keyword="Win32Proj">
+	<Platforms>
+		<Platform
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="2"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalOptions="/D &quot;TIXML_USE_STL&quot;"
+				Optimization="0"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Samples/Common/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;;../include/IMG;../include/BBC;../include/LBBC"
+				PreprocessorDefinitions="WIN32;_DEBUG;_USRDLL;_MT"
+				MinimalRebuild="TRUE"
+				BasicRuntimeChecks="3"
+				SmallerTypeCheck="TRUE"
+				RuntimeLibrary="3"
+				BufferSecurityCheck="TRUE"
+				EnableFunctionLevelLinking="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="4"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalOptions=" /IMPLIB:&quot;..\bin\debug\$(ProjectName)_d.lib&quot; "
+				AdditionalDependencies="Ogremain_d.lib"
+				OutputFile="$(OutDir)/$(ProjectName)_d.dll"
+				LinkIncremental="2"
+				SuppressStartupBanner="TRUE"
+				AdditionalLibraryDirectories="$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)"
+				IgnoreDefaultLibraryNames="LIBCD;LIBCMTD"
+				GenerateDebugInformation="TRUE"
+				SubSystem="1"
+				OptimizeForWindows98="1"
+				ImportLibrary="$(OutDir)/$(ProjectName).lib"
+				TargetMachine="1"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"
+				CommandLine="copy ..\bin\debug\LeavesBillboardCloudGenerator_d.dll ..\..\..\..\..\..\App\Tools\IBRTreesModuleTools\LeavesBillboardCloudMayaToolkit\bin\debug
+copy ..\bin\debug\LeavesBillboardCloudGenerator_d.dll ..\..\..\..\..\..\App\Tools\IBRTreesModuleTools\LeavesBillboardCloudCommandLine\bin\debug
+"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="2"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalOptions="/D &quot;TIXML_USE_STL&quot;"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;;&quot;$(OGRE_PATH)/Samples/Common/include&quot;;../include/IMG;../include/BBC;../include/LBBC"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
+				RuntimeLibrary="2"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalOptions=" /IMPLIB:&quot;..\bin\release\$(ProjectName).lib&quot; "
+				AdditionalDependencies="OgreMain.lib"
+				LinkIncremental="1"
+				SuppressStartupBanner="TRUE"
+				AdditionalLibraryDirectories="$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)"
+				SubSystem="1"
+				OptimizeReferences="2"
+				EnableCOMDATFolding="2"
+				OptimizeForWindows98="1"
+				ImportLibrary="$(OutDir)/$(ProjectName).lib"
+				TargetMachine="1"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"
+				CommandLine="copy ..\bin\release\LeavesBillboardCloudGenerator.dll ..\..\..\..\..\..\App\Tools\IBRTreesModuleTools\LeavesBillboardCloudMayaToolkit\bin\release
+copy ..\bin\release\LeavesBillboardCloudGenerator.dll ..\..\..\..\..\..\App\Tools\IBRTreesModuleTools\LeavesBillboardCloudCommandLine\bin\release
+"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="Source Files"
+			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
+			<File
+				RelativePath="..\src\BBCBillboard.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCBillboardCloud.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCBillboardCloudGenerator.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCBillboardCloudSerializer.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCBillboardCloudTextureGenerator.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCBillboardCloudUVMapper.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCBillboardClusterData.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCBillboardGroup.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCEntity.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCEntityCluster.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCEntityClusterData.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCEntityDistribution.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCEntityDistributionGenerator.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCEntityDistributionSerializer.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCOgreMeshSerializer.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCSubEntity.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCTimer.cpp">
+			</File>
+			<File
+				RelativePath="..\src\BBCXmlSerializer.cpp">
+			</File>
+			<File
+				RelativePath="..\src\IMGBBox.cpp">
+			</File>
+			<File
+				RelativePath="..\src\IMGBox2d.cpp">
+			</File>
+			<File
+				RelativePath="..\src\IMGBsp.cpp">
+			</File>
+			<File
+				RelativePath="..\src\IMGCluster.cpp">
+			</File>
+			<File
+				RelativePath="..\src\IMGCluster2d.cpp">
+			</File>
+			<File
+				RelativePath="..\src\IMGClusterList.cpp">
+			</File>
+			<File
+				RelativePath="..\src\IMGNodeBsp.cpp">
+			</File>
+			<File
+				RelativePath="..\src\IMGPlane3.cpp">
+			</File>
+			<File
+				RelativePath="..\src\IMGVoxel.cpp">
+			</File>
+			<File
+				RelativePath="..\src\IMGVoxelList.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCBillboardKdTreeClusterData.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCBillboardKMeansClusterData.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCKdTreeClusterGenerator.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCKdTreeClusterSerializer.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCKMeansClusterGenerator.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCKMeansClusterSerializer.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCLeaf.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCLeafDistribution.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCLeafDistributionGenerator.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCLeafDistributionSerializer.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCLeafKdTreeClusterData.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCLeafKMeansClusterData.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCLeaves.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCManager.cpp">
+			</File>
+			<File
+				RelativePath="..\src\LBBCSampleConfigFile.cpp">
+			</File>
+			<File
+				RelativePath="..\..\..\..\..\..\..\Ogre\trunk\ogrenew\Tools\XMLConverter\src\OgreXMLMeshSerializer.cpp">
+			</File>
+			<File
+				RelativePath="..\..\..\..\..\..\..\Ogre\trunk\ogrenew\Tools\XMLConverter\src\tinystr.cpp">
+			</File>
+			<File
+				RelativePath="..\..\..\..\..\..\..\Ogre\trunk\ogrenew\Tools\XMLConverter\src\tinyxml.cpp">
+			</File>
+			<File
+				RelativePath="..\..\..\..\..\..\..\Ogre\trunk\ogrenew\Tools\XMLConverter\src\tinyxmlerror.cpp">
+			</File>
+			<File
+				RelativePath="..\..\..\..\..\..\..\Ogre\trunk\ogrenew\Tools\XMLConverter\src\tinyxmlparser.cpp">
+			</File>
+		</Filter>
+		<Filter
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl;inc;xsd"
+			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
+			<File
+				RelativePath="..\include\Bbc\BBC.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCBillboard.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCBillboardCloud.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCBillboardCloudGenerator.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCBillboardCloudSerializer.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCBillboardCloudTextureGenerator.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCBillboardCloudUVMapper.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCBillboardClusterData.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCBillboardGroup.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCEntity.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCEntityCluster.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCEntityClusterData.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCEntityDistribution.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCEntityDistributionGenerator.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCEntityDistributionSerializer.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCManager.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCOgreMeshSerializer.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCPrerequisites.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCSingleton.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCSubEntity.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCTimer.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCUtil.h">
+			</File>
+			<File
+				RelativePath="..\include\Bbc\BBCXmlSerializer.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMG.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMGBBox.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMGBox2d.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMGBsp.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMGCluster.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMGCluster2d.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMGClusterList.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMGNodeBsp.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMGPlane3.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMGPrerequisites.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMGVoxel.h">
+			</File>
+			<File
+				RelativePath="..\include\Img\IMGVoxelList.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBC.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCBillboardKdTreeClusterData.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCBillboardKMeansClusterData.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCKdTreeClusterGenerator.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCKdTreeClusterSerializer.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCKMeansClusterGenerator.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCKMeansClusterSerializer.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCLeaf.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCLeafDistribution.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCLeafDistributionGenerator.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCLeafDistributionSerializer.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCLeafKdTreeClusterData.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCLeafKMeansClusterData.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCLeaves.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCManager.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCPrerequisites.h">
+			</File>
+			<File
+				RelativePath="..\include\Lbbc\LBBCSampleConfigFile.h">
+			</File>
+			<File
+				RelativePath="..\..\..\..\..\..\..\Ogre\trunk\ogrenew\Tools\XMLConverter\include\OgreXMLMeshSerializer.h">
+			</File>
+			<File
+				RelativePath="..\..\..\..\..\..\..\Ogre\trunk\ogrenew\Tools\XMLConverter\include\OgreXMLPrerequisites.h">
+			</File>
+			<File
+				RelativePath="..\..\..\..\..\..\..\Ogre\trunk\ogrenew\Tools\XMLConverter\include\tinystr.h">
+			</File>
+			<File
+				RelativePath="..\..\..\..\..\..\..\Ogre\trunk\ogrenew\Tools\XMLConverter\include\tinyxml.h">
+			</File>
+		</Filter>
+		<Filter
+			Name="Resource Files"
+			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe;resx"
+			UniqueIdentifier="{67DA6AB6-F800-4c08-8B7A-83BB121AAD01}">
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGeneratorCommandLine.vcproj
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGeneratorCommandLine.vcproj	(revision 698)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGeneratorCommandLine.vcproj	(revision 698)
@@ -0,0 +1,138 @@
+<?xml version="1.0" encoding="Windows-1252"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="7.10"
+	Name="IBRBillboardCloudTreeGeneratorCommandLine"
+	ProjectGUID="{3C400FBE-9DA8-4553-BEA9-ABEA8A2575F9}"
+	Keyword="Win32Proj">
+	<Platforms>
+		<Platform
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="1"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				AdditionalIncludeDirectories="../include;../include/BBC;../include/IMG;../include/LBBC;&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;"
+				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE"
+				MinimalRebuild="TRUE"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="1"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="4"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="odbc32.lib kernel32.lib odbccp32.lib IBRBillboardCloudTreeGenerator_d.lib OgreMain_d.lib"
+				OutputFile="$(OutDir)/IBRBillboardCloudTreeGeneratorCmd_d.exe"
+				LinkIncremental="2"
+				AdditionalLibraryDirectories="../bin/$(ConfigurationName);$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)"
+				GenerateDebugInformation="TRUE"
+				ProgramDatabaseFile="$(OutDir)/scripts.pdb"
+				SubSystem="1"
+				TargetMachine="1"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
+			ConfigurationType="1"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="../include;../include/BBC;../include/IMG;../include/LBBC;&quot;$(OGRE_PATH)/OgreMain/include&quot;;&quot;$(OGRE_PATH)/Tools/XMLConverter/include&quot;"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE"
+				RuntimeLibrary="0"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="odbc32.lib kernel32.lib odbccp32.lib IBRBillboardCloudTreeGenerator.lib OgreMain.lib"
+				OutputFile="$(OutDir)/IBRBillboardCloudGeneratorCmd.exe"
+				LinkIncremental="1"
+				AdditionalLibraryDirectories="../bin/$(ConfigurationName);$(OGRE_PATH)/OgreMain/lib/$(ConfigurationName)"
+				GenerateDebugInformation="TRUE"
+				SubSystem="1"
+				OptimizeReferences="2"
+				EnableCOMDATFolding="2"
+				TargetMachine="1"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="Source Files"
+			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
+			<File
+				RelativePath="..\src\main.cpp">
+			</File>
+		</Filter>
+		<Filter
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl;inc;xsd"
+			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
+		</Filter>
+		<Filter
+			Name="Resource Files"
+			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe;resx"
+			UniqueIdentifier="{67DA6AB6-F800-4c08-8B7A-83BB121AAD01}">
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>